# Protamine Analysis

``ProtamineAnalysis`` provides commandline user interface to analyses and predict the functionally import residues in
vertebrate sperm protamine amino acids sequences.


## Installation

The ``ProtamineAnalysis`` package has been tested to work on Unix based systems and Python 3.4+. Use pip to install all
python dependencies.


### Pip

```
python3 -m pip install requirements.txt
```


### Dependencies

The ``ProtamineAnalysis`` requires a **non-pip-installable** dependency: the
[MUSCLE](https://www.drive5.com/muscle/) standalone binary version 3.8.31 or later.

Refer to the official documentation to install [MUSCLE](https://www.drive5.com/muscle/) on your system:

   * Official Installation Instructions: https://www.drive5.com/muscle/manual/install.html


## Running ProtamineAnalysis

``ProtamineAnalysis`` can be ran via a bash script, python scripts, or via a python notebook file.


### ProtamineAnalysis.sh

```
bash ProtamineAnalysis.sh
```


### GenerateDataSets.py

To only generate the .json files for the four protamine group alignments.

```
[ProtamineAnalysis]# python3 GenerateDatasets.py
```


### ProtamineAnalysis.py

To only generate commandline output for ``ProtamineAnalysis``.

```
[ProtamineAnalysis]# python3 GenerateDatasets.py
```


### ProtamineAnalysis.ipynb


## Data Files

Included with the ``ProtamineAnalysis`` repository are a number of data files.
```
ProtamineAnalysis
│
└───Docs
│   │
│   └───Datasets
│   │   │   eutherian_p1.json
│   │   │   eutherian_p2.json
│   │   │   fish.json
│   │   │   metatherian.json
│   │   │   uniprot_2019_05.xml
│   │
│   └───Images
│       │   figure_1.png
│       │   ...
│
│   ...
```

### .json files

JSON files for each of the generated alignments are included in the repository.


### uniprot_2019_05.xml

Included in the repository is the source protamine dataset (Docs/Datasets/uniprot_2019_05.xml) as downloaded from
UniProt in May of 2019.


## License

This package is distributed under the [BSD](https://choosealicense.com/licenses/bsd-3-clause-clear) license.